package com.example.googlemapproject;

//import android.app.Activity;

//import com.google.android.gms.maps.GoogleMap;
//import com.google.android.gms.maps.model.LatLng;
//import com.google.android.gms.maps.model.MarkerOptions;
//import com.google.android.gms.maps.SupportMapFragment;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdate;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.LatLngBounds;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.VisibleRegion;

//import com.google.android.maps.MapActivity;

public class MapActivity extends FragmentActivity {
	static final LatLng JOENSUU = new LatLng(62.600293, 29.757843);
	private SupportMapFragment mMapFragment;

	private GoogleMap googleMap;

	private static final String TAG_STUDENTS = "students";
	private static final String TAG_NAME = "name";
	private static final String TAG_LAT = "latitude";
	private static final String TAG_LON = "longitude";
	private static final String TAG_PRG = "program";
	private static final String TAG_CON = "country";
	private static final String TAG_SY = "startYear";
	private static final String TAG_GY = "graduationYear";
	Spinner spn_con, spn_prg, spn_sy, spn_gy;
	//LatLngBounds.Builder builder1 = new LatLngBounds.Builder();
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		mMapFragment = ((SupportMapFragment) getSupportFragmentManager()
				.findFragmentById(R.id.map));
		googleMap = mMapFragment.getMap();
		googleMap = ((SupportMapFragment) (getSupportFragmentManager()
				.findFragmentById(R.id.map))).getMap();
		
		
		
		// String studentsString = getStudentsJSON();
		DownloadWebpageTask myTask = new DownloadWebpageTask(this);
		myTask.execute("http://cs.joensuu.fi/lamad/server.php?param={%22request_type%22:%22get_students_with_params%22,%22program%22:%22%22}");

		spn_con = (Spinner) findViewById(R.id.spinner1);
		spn_prg = (Spinner) findViewById(R.id.spinner2);
		spn_sy = (Spinner) findViewById(R.id.spinner3);
		spn_gy = (Spinner) findViewById(R.id.spinner4);

		// Spinner for country
		ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(
				this, R.array.country_arrays,
				android.R.layout.simple_spinner_item);

		adapter.setDropDownViewResource(android.R.layout.select_dialog_singlechoice);

		spn_con.setAdapter(adapter);

		// Spinner for Program
		ArrayAdapter<CharSequence> adapter_prg = ArrayAdapter
				.createFromResource(this, R.array.program_arrays,
						android.R.layout.simple_spinner_item);

		adapter_prg
				.setDropDownViewResource(android.R.layout.select_dialog_singlechoice);

		spn_prg.setAdapter(adapter_prg);

		// Spinner for Start Year
		ArrayAdapter<CharSequence> adapter_sy = ArrayAdapter
				.createFromResource(this, R.array.start_year_arrays,
						android.R.layout.simple_spinner_item);

		adapter_sy
				.setDropDownViewResource(android.R.layout.select_dialog_singlechoice);

		spn_sy.setAdapter(adapter_sy);

		// Spinner for Graduation Year
		ArrayAdapter<CharSequence> adapter_gy = ArrayAdapter
				.createFromResource(this, R.array.grad_year_arrays,
						android.R.layout.simple_spinner_item);

		adapter_gy
				.setDropDownViewResource(android.R.layout.select_dialog_singlechoice);

		spn_gy.setAdapter(adapter_gy);

	}

	/*public void changeMarkerPosition(double lat1, double lon1) {
		double lat = lat1;

		double lon = lon1;
		// if((spn_con.getSelectedItem()=="Country")&&())
		googleMap.animateCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(
				lat, lon), 4));
	}
*/	
	public void displayMarker(LatLng studentPosition,String name,String concat, String prg, int zoom)
	{
		
				if("IMPIT".equals(prg))
		{
			 //builder1.include(studentPosition);
		
		googleMap.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		googleMap.addMarker(new MarkerOptions()
						.position(studentPosition)
						.title(name)
						.snippet(concat)
						.icon(BitmapDescriptorFactory
								.defaultMarker(BitmapDescriptorFactory.HUE_ORANGE)));
		}
		else{
			//builder1.include(studentPosition);
			googleMap.setMapType(GoogleMap.MAP_TYPE_NORMAL);
			googleMap.addMarker(new MarkerOptions()
							.position(studentPosition)
							.title(name)
							.snippet(concat)
							.icon(BitmapDescriptorFactory
									.defaultMarker(BitmapDescriptorFactory.HUE_AZURE)));
				
			
			
		}
		googleMap.getUiSettings().setCompassEnabled(true);
		googleMap.getUiSettings().setZoomControlsEnabled(true);
		googleMap.animateCamera(CameraUpdateFactory.newLatLngZoom(studentPosition, zoom));
	
		
		
	}

	public void sortList(final String data) {
		googleMap.clear();
		String startYear = null;
		String graduationYear = null;
		String country = null;
		String program = null;
		if (spn_con.getSelectedItem() != null) {
			country = String.valueOf(spn_con.getSelectedItem());
			// Toast.makeText(getApplicationContext(), country,
			// Toast.LENGTH_LONG).show();
		}
		if (spn_prg.getSelectedItem() != null) {

			program = String.valueOf(spn_prg.getSelectedItem());
		}
		if (spn_sy.getSelectedItem() != null) {
			startYear = String.valueOf(spn_sy.getSelectedItem());
		}
		if (spn_gy.getSelectedItem() != null) {
			graduationYear = String.valueOf(spn_gy.getSelectedItem());
		}

		try {
			JSONArray students1;
			JSONObject jArray1 = null;

			jArray1 = new JSONObject(data);

			// Getting Array of students
			students1 = jArray1.getJSONArray(TAG_STUDENTS);

			//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();
			// 1. All the spinners are selected
			if ((!"Country".equals(spn_con.getSelectedItem())) && (!"Program".equals(spn_prg.getSelectedItem())) && (!"Start Year".equals(spn_sy.getSelectedItem())) && (!"Grad Year".equals(spn_gy.getSelectedItem()))) 
			{
				int msg_val=0;

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) 
				{

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					
					if ((con.equals(country)) && (prg.equals(program)) && (sy.equals(startYear)) && (gy.equals(graduationYear))) 
					{
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						//Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
						
						msg_val=1;		
						
					}
				}
				if(msg_val==0)
				{
					Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
				}
			
				
			}
			// 2. Spinner GY not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& (!"Start Year".equals(spn_sy.getSelectedItem()))
					&& (graduationYear.equals("Grad Year"))) {

				int msg_val=0;
				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country)) && (prg.equals(program))
							&& (sy.equals(startYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						msg_val=1;
						
							
						
					}				
					}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			
			}

			// 4. Spinner country is selected but GY,SY and Program not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& (graduationYear.equals("Grad Year"))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"This is" + spn_gy.getSelectedItem(), Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						
					}

				}
			if(msg_val==0)
			{
				//Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}

			}

			// 3. Spinner Start year and Grad year are not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& ("Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				
				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country)) && (prg.equals(program))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						
					}

				}

			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 5.No spinner is selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& ("Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);

					String name = student1.getString(TAG_NAME);

					double lat = student1.getDouble(TAG_LAT);
					double lon = student1.getDouble(TAG_LON);
					String concat = prg + " " + sy + " " + con;
					LatLng studentPosition = new LatLng(lat, lon);
					displayMarker(studentPosition,name,concat,prg,0);
					msg_val=1;
						
					// changeMarkerPosition(lat, lon);
					// break outerloop;
					

				}
			
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			
			
			
			}

			// 6. Country spinner is not selected, but others are selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& (!"Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {

				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((prg.equals(program)) && (sy.equals(startYear))
							&& (gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,0);
						msg_val=1;
							
						
						// changeMarkerPosition(lat, lon);
						// break outerloop;

						
					}				
					}
			
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}

			// 7. Spinners start and grad are selected but others are not
			// selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& (!"Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {

				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((sy.equals(startYear)) && (gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,0);
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						
					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}

			// 9. Spinners country and graduation year are selected but program
			// and start year are not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {

				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country)) && (gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						
					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 10. Spinners country, program and graduation year are selected
			// but start year is not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),	"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country)) && (prg.equals(program))
							&& (gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						msg_val=1;
						
									
						// changeMarkerPosition(lat, lon);
						// break outerloop;

					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 11. Spinners country, program and start year are not selected but
			// graduation year is selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,0);
						
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;

					}

				}
			if(msg_val==0)
			{
				//Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 12. Spinner program is selected but country, start year and
			// graduation year are not selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& ("Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if (prg.equals(program)) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,0);
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						
					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 13. Spinners country and start year are selected but program and
			// graduation year are not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& (!"Start Year".equals(spn_sy.getSelectedItem()))
					&& ("Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country)) && (sy.equals(startYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						msg_val=1;
								
					}
				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}

			// 14.Spinners program and graduation year are selected but country
			// and start year are not selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& ("Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((prg.equals(program)) && (gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,0);
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						msg_val=1;
								
					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 15. Spinners program and start year are selected but country and
			// graduation year are not selected
			else if (("Country".equals(spn_con.getSelectedItem()))
					&& (!"Program".equals(spn_prg.getSelectedItem()))
					&& (!"Start Year".equals(spn_sy.getSelectedItem()))
					&& ("Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((prg.equals(program)) && (sy.equals(startYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,0);
						msg_val=1;
							
						// changeMarkerPosition(lat, lon);
						// break outerloop;
					
					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}

			// 16. Spinners country, start year and graduation year are selected
			// but program is not selected
			else if ((!"Country".equals(spn_con.getSelectedItem()))
					&& ("Program".equals(spn_prg.getSelectedItem()))
					&& (!"Start Year".equals(spn_sy.getSelectedItem()))
					&& (!"Grad Year".equals(spn_gy.getSelectedItem()))) {
				int msg_val=0;
				//Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

				// Looping through all students
				outerloop: for (int i = 0; (i < students1.length()); i++) {

					JSONObject student1 = students1.getJSONObject(i);

					// Storing each json item in variable

					String con = student1.getString(TAG_CON);
					String prg = student1.getString(TAG_PRG);
					String sy = student1.getString(TAG_SY);
					String gy = student1.getString(TAG_GY);
					if ((con.equals(country)) && (sy.equals(startYear))
							&& (gy.equals(graduationYear))) {
						String name = student1.getString(TAG_NAME);

						double lat = student1.getDouble(TAG_LAT);
						double lon = student1.getDouble(TAG_LON);
						String concat = prg + " " + sy + " " + con;
						LatLng studentPosition = new LatLng(lat, lon);
						displayMarker(studentPosition,name,concat,prg,4);
						// changeMarkerPosition(lat, lon);
						// break outerloop;
						msg_val=1;
						
							
					}

				}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
			}
			// 17. Spinner Start year is selected others are not selected
			else if (("Country".equals(spn_con.getSelectedItem())) && ("Program".equals(spn_prg.getSelectedItem())) && (!"Start Year".equals(spn_sy.getSelectedItem())) && ("Grad Year".equals(spn_gy.getSelectedItem()))) 
						{
				int msg_val=0;
						//	Toast.makeText(getApplicationContext(),"Graduation Year" + graduationYear, Toast.LENGTH_LONG).show();

							// Looping through all students
							outerloop: for (int i = 0; (i < students1.length()); i++) {

								JSONObject student1 = students1.getJSONObject(i);

								String con = student1.getString(TAG_CON);
								String prg = student1.getString(TAG_PRG);
								String sy = student1.getString(TAG_SY);
								String gy = student1.getString(TAG_GY);
								if ( sy.equals(startYear) ) 
								{
									String name = student1.getString(TAG_NAME);

									double lat = student1.getDouble(TAG_LAT);
									double lon = student1.getDouble(TAG_LON);
									String concat = prg + " " + sy + " " + con;
									LatLng studentPosition = new LatLng(lat, lon);
									displayMarker(studentPosition,name,concat,prg,0);
									
									msg_val=1;
									
										
								}

							}
			if(msg_val==0)
			{
				Toast.makeText(getApplicationContext(),"No results found!", Toast.LENGTH_LONG).show();
			}
						}


			else {

				Toast.makeText(getApplicationContext(), "Some Error",
						Toast.LENGTH_LONG).show();

			}
			/*LatLngBounds bounds = builder1.build();
		//	bounds.
			
			int padding = 0; // offset from edges of the map in pixels
			CameraUpdate cu = CameraUpdateFactory.newLatLngBounds(bounds, padding);
			googleMap.animateCamera(cu);*/
		

		} catch (JSONException e) {
			// e.printStackTrace();
			Log.d("new_err", e.toString());
			Toast.makeText(getApplicationContext(), e.toString(),
					Toast.LENGTH_LONG).show();
		}
		// Toast.makeText(getApplicationContext(), country,
		// Toast.LENGTH_LONG).show();

	}

	public void setFilter(final String data) {

		spn_con.setOnItemSelectedListener(new OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> parentView,
					View selectedItemView, int position, long id) {
				// your code here
				sortList(data);
			}

			@Override
			public void onNothingSelected(AdapterView<?> parentView) {
				// your code here
			}
		});

		spn_prg.setOnItemSelectedListener(new OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> parentView,
					View selectedItemView, int position, long id) {
				// your code here
				sortList(data);
			}

			@Override
			public void onNothingSelected(AdapterView<?> parentView) {
				// your code here
			}

		});

		spn_sy.setOnItemSelectedListener(new OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> parentView,
					View selectedItemView, int position, long id) {
				// your code here
				sortList(data);
			}

			@Override
			public void onNothingSelected(AdapterView<?> parentView) {
				// your code here
			}
		});

		spn_gy.setOnItemSelectedListener(new OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> parentView,
					View selectedItemView, int position, long id) {
				// your code here
				sortList(data);
			}

			@Override
			public void onNothingSelected(AdapterView<?> parentView) {
				// your code here
			}
		});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public void processFetchedData(String data) {
		// Toast.makeText(getApplicationContext(), data,
		// Toast.LENGTH_LONG).show();

		// String data1=data;
  /* double min_lat=0;
   double max_lat=0;
   double min_lon=0;
   double max_lon=0;
	*/	try {
	
			LatLngBounds.Builder builder = new LatLngBounds.Builder();
			
			JSONArray students;
			JSONObject jArray = null;

			jArray = new JSONObject(data);

			// Getting Array of students
			students = jArray.getJSONArray(TAG_STUDENTS);

			// Looping through all students
			for (int i = 0; i < students.length(); i++) {
				JSONObject student = students.getJSONObject(i);

				// Storing each json item in variable
				String name = student.getString(TAG_NAME);
				double lat = student.getDouble(TAG_LAT);
				double lon = student.getDouble(TAG_LON);
				String prg = student.getString(TAG_PRG);
				String con = student.getString(TAG_CON);
				String sy = student.getString(TAG_SY);
				String concat = prg + " " + sy + " " + con;
				LatLng studentPosition = new LatLng(lat, lon);
		        builder.include(studentPosition);
				googleMap.setMapType(GoogleMap.MAP_TYPE_NORMAL);
             	if("IMPIT".equals(prg))
				{
				googleMap.addMarker(new MarkerOptions()
								.position(studentPosition)
								.title(name)
								.snippet(concat)
								.icon(BitmapDescriptorFactory
										.defaultMarker(BitmapDescriptorFactory.HUE_ORANGE)));
				}
				else{
					googleMap.addMarker(new MarkerOptions()
							.position(studentPosition)
							.title(name)
							.snippet(concat)
							.icon(BitmapDescriptorFactory
									.defaultMarker(BitmapDescriptorFactory.HUE_AZURE)));
			}
			
			
				googleMap.getUiSettings().setCompassEnabled(true);
				googleMap.getUiSettings().setZoomControlsEnabled(true);
				//googleMap.animateCamera(CameraUpdateFactory.newLatLngZoom(
					//	studentPosition, 5));
				LatLngBounds bounds = builder.build();
				int padding = 0; // offset from edges of the map in pixels
				CameraUpdate cu = CameraUpdateFactory.newLatLngBounds(bounds, padding);
	            googleMap.moveCamera(cu);
	            //googleMap.animateCamera(CameraUpdateFactory.zoomTo(3));
				
			
			}

		} catch (JSONException e) {
			// e.printStackTrace();
			Log.d("new_err", e.toString());
			Toast.makeText(getApplicationContext(), "am i here"+e.toString(),
					Toast.LENGTH_LONG).show();
		}
        //fitMapOnScreen(min_lat,max_lat,min_lon,max_lon);
		// googleMap.clear();
		setFilter(data);
		// sortList(data);
	}
	public void  fitMapOnScreen(double min_lat,double max_lat,double min_lon,double max_lon)
	{
	   //mMapController = googleMap.g
		
	}

	/*public static String convertURL(String str) {

		String url = null;
		try {
			url = new String(str.trim().replace(" ", "%20").replace("&", "%26")
					.replace(",", "%2c").replace("(", "%28")
					.replace(")", "%29").replace("!", "%21")
					.replace("=", "%3D").replace("<", "%3C")
					.replace(">", "%3E").replace("#", "%23")
					.replace("$", "%24").replace("'", "%27")
					.replace("*", "%2A").replace("-", "%2D")
					.replace(".", "%2E").replace("/", "%2F")
					.replace(":", "%3A").replace(";", "%3B")
					.replace("?", "%3F").replace("@", "%40")
					.replace("[", "%5B").replace("\\", "%5C")
					.replace("]", "%5D").replace("_", "%5F")
					.replace("`", "%60").replace("{", "%7B")
					.replace("|", "%7C").replace("}", "%7D"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		return url;
	}*/
}