package com.example.helloworld;

import android.app.*;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

public class DataInputActivity extends Activity {
	private EditText first_name;
	private EditText last_name;
	private EditText age;
	private EditText city;
	private Button submit;
	private Button cancel;
	private Person person;

@Override
protected void onCreate(Bundle savedInstanceState) {
	super.onCreate(savedInstanceState);
    setContentView(R.layout.home);  

    first_name = (EditText)findViewById(R.id.first_name);
    last_name = (EditText)findViewById(R.id.last_name);
    age = (EditText)findViewById(R.id.age);
    city = (EditText)findViewById(R.id.city);
    submit = (Button)findViewById(R.id.VaihdaKarttaAsetus);
    cancel = (Button)findViewById(R.id.friendsinmapbtn);
    
    
    submit.setOnClickListener(new View.OnClickListener() {
    	public void onClick(View v) {
           store_data();
          }
         });
   
    cancel.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
           first_name.setText("");
           last_name.setText("");
           age.setText("");
           city.setText("");
          }
         });  
  }
  
  private void store_data(){
	   String fName = first_name.getText().toString(); 
	   String lName = last_name.getText().toString();
	   String a = age.getText().toString();
	   String c = city.getText().toString();
	   boolean empty = false;
	   if(fName.length() == 0){
		    first_name.setBackgroundColor(Color.CYAN);
		    empty = true;   
	   }
	   if(lName.length() == 0){
		    last_name.setError("Last Name is required");
		    empty = true;
	   }
	   if(a.length() == 0){
		    	age.setError("Age is required");
		    	empty = true;
		   }else{
			    if(isInteger(a) == true){}
			else{
			   	age.setError("Age not valid");
		   }
	   }
	   if(c.length()== 0){
		    city.setError("City Name is required");
		    empty = true;
	   }  
	   if(empty == false){
		   // person = new Person(fName, lName, Integer.parseInt(a), c);
		    Intent intent = new Intent (DataInputActivity.this, ShowOutput.class);
		    intent.putExtra("person", person);
		    startActivity(intent);
	   }  
  }
 
  private boolean isInteger(String age){
	   try{
		   Integer.parseInt(age);
		   return true;
	   }catch (Exception e) {
		   return false;
	   }
  }
 }
