package com.example.helloworld;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
 
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
 
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.StrictMode;
import android.util.Log;
 
public class JSONparseri {
	
    JSONObject jsonObj = new JSONObject();
    JSONArray jsonArray = new JSONArray();
    URI finalUri;
    
    public void Main () { 
        //super.onCreate(savedInstanceState); 
        //moveTaskToBack(true);
        //setContentView(R.layout.json_tulosruutu); 
    
    	      
    	// setThreadPolicy does not work with 2.2 (Froyo). Should be called only with gingerbread and newer versions
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.GINGERBREAD) {
        	StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().detectDiskReads().detectDiskWrites().detectNetwork().penaltyLog().build());
        }
    	writeJSON();
        
        String sMopsiQuery = new String("http://cs.joensuu.fi/lamad/server.php?param={\"request_type\":\"get_students_with_params\",\"program\":\"CBU\"}");
        sMopsiQuery.replaceAll(" ", "%20");
        
        testURL(sMopsiQuery);
        
        String readMopsiFeed = readMopsiStudents(finalUri);
        try {
        	
        	JSONObject jObject = new JSONObject(readMopsiFeed);
        	
            jsonArray = jObject.getJSONArray("students");
        	
            Log.i(JSONparseri.class.getName(),
                    "Number of entries " + jsonArray.length());
           
                       
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject jsonObject = jsonArray.getJSONObject(i);
                String personInfo = "";
                personInfo = jsonObject.getString("name") + ",";
                personInfo = personInfo + jsonObject.getString("country");
                personInfo = personInfo + ", lat: " + jsonObject.getDouble("latitude");
                personInfo = personInfo + ", lon: " + jsonObject.getDouble("longitude");
                Log.i(JSONparseri.class.getName(), personInfo);
                //Log.i(JSONparseri.class.getName(), jsonObject.getString("country"));
             
                //Double latitude, longitude;
                //latitude = jsonObject.getDouble("latitude");
                //longitude = jsonObject.getDouble("longitude");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //AnttiV: 
    public JSONArray getListAsJSONArray(){    	
    	return jsonArray;
    }
    
    
    
    public void testURL(String sURI){
    try {
        	URL url = new URL(sURI);
        	String nullFragment = null;
        	URI uri = new URI(url.getProtocol(), url.getHost(), url.getPath(), url.getQuery(), nullFragment);
        	System.out.println("URI " + uri.toString() + " is OK");
        	finalUri = uri;
        	
      } catch (MalformedURLException e) {
    	  System.out.println("URL " + sURI + " is a malformed URL");
      } catch (URISyntaxException e) {
    	  System.out.println("URI " + sURI + " is a malformed URL");
      }
    }
    
    public String readMopsiStudents(URI validatedURI) {
        StringBuilder builder = new StringBuilder();
        HttpClient client = new DefaultHttpClient();

        
        //String sMopsiQuery = new String("http://cs.joensuu.fi/lamad/server.php?param=");
        //sMopsiQuery.replaceAll(" ", "%20");
        //sMopsiQuery = sMopsiQuery + jsonObj.toString();
        //HttpGet httpGet = new HttpGet("http://twitter.com/statuses/user_timeline/vogella.json");
        
        HttpGet httpGet = new HttpGet(validatedURI);
//http://cs.joensuu.fi/lamad/server.php?param={\"request_type\":\"get_students_with_params\",\"program\":\"CBU\"}        
        try {
            HttpResponse response = client.execute(httpGet);
            StatusLine statusLine = response.getStatusLine();
            int statusCode = statusLine.getStatusCode();
            if (statusCode == 200) {
                HttpEntity entity = response.getEntity();
                InputStream content = entity.getContent();
                BufferedReader reader = new BufferedReader(
                        new InputStreamReader(content));
                String line;
                while ((line = reader.readLine()) != null) {
                    builder.append(line + "\n");
                }
            } else {
                Log.e(JSONparseri.class.toString(), "Failed to download file");
            }
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return builder.toString();
   }
   public void writeJSON() {
        try {
        	
        	jsonObj.put("request_type", "get_students_with_params");
        	jsonObj.put("program", "CBU");

        } catch (JSONException e) {
            e.printStackTrace();
        }
        System.out.println(jsonObj);
    }
}
