package com.example.helloworld;

import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.support.v4.app.FragmentActivity;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnMapLongClickListener;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;

import com.google.android.gms.maps.GoogleMap.OnMapClickListener;
import com.google.android.gms.maps.model.MarkerOptions;


public class KarttaRuutu extends FragmentActivity implements LocationListener, OnMapClickListener, OnMapLongClickListener {
	private Button alkuunbutton;
	private Button kaveritkartassabtn;
	GoogleMap googleMap;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.karttaikkuna);
		
        // Getting Google Play availability status
        int status = GooglePlayServicesUtil.isGooglePlayServicesAvailable(getBaseContext());

        // Showing status
        if(status!=ConnectionResult.SUCCESS){ // Google Play Services are not available
 
            int requestCode = 10;
            Dialog dialog = GooglePlayServicesUtil.getErrorDialog(status, this, requestCode);
            dialog.show();
 
        }else { // Google Play Services are available
         	  	
        	// Getting reference to the SupportMapFragment of activity_main.xml
            SupportMapFragment fm = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
 
            // Getting GoogleMap object from the fragment
            googleMap = fm.getMap();
 
            // Enabling MyLocation Layer of Google Map
            googleMap.setMyLocationEnabled(true);
            
            // AnttiV: Listn mys kompassi ja muut lisominaisuudet karttankymn
            googleMap.getUiSettings().setCompassEnabled(true);
            googleMap.getUiSettings().setAllGesturesEnabled(true);
            
            // AnttiV: Alustetaan listenerit merkin lismiseksi karttaan
    		googleMap.setOnMapClickListener(this);
            googleMap.setOnMapLongClickListener(this); 
            
            // Getting LocationManager object from System Service LOCATION_SERVICE
            LocationManager locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
 
            // Creating a criteria object to retrieve provider
            Criteria criteria = new Criteria();
 
            // Getting the name of the best provider
            String provider = locationManager.getBestProvider(criteria, true);
 
            // Getting Current Location
            Location location = locationManager.getLastKnownLocation(provider);
 
            if(location!=null){
                onLocationChanged(location);
            }
            locationManager.requestLocationUpdates(provider, 20000, 0, this);
        }	

        
        // AnttiV: Karttankymst takaisin-painike  
		alkuunbutton = (Button)findViewById(R.id.alkuunkartassa);
	    
		alkuunbutton.setOnClickListener(new View.OnClickListener() {
 	    	public void onClick(View v) {
 				Intent intent = new Intent (KarttaRuutu.this, MainMenu.class);                      
 				startActivity(intent);
 				finish();
 	          }
 	         });
		
        // AnttiV: Kaverit kartalle -painike  (viel on kesken tm...)
		
		kaveritkartassabtn = (Button)findViewById(R.id.friendsinmapbtn);
	    
		kaveritkartassabtn.setOnClickListener(new View.OnClickListener() {
 	    	public void onClick(View v) {
 				Intent intent = new Intent (KarttaRuutu.this, KaveriLista.class);                      
 				startActivity(intent);
 				finish();
 	          }
 	         });
		
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
        
        // Getting latitude of the current location
        double latitude = location.getLatitude();
 
        // Getting longitude of the current location
        double longitude = location.getLongitude();
 
        // Creating a LatLng object for the current location
        LatLng latLng = new LatLng(latitude, longitude);
 
        // Showing the current location in Google Map
        googleMap.moveCamera(CameraUpdateFactory.newLatLng(latLng));
 
        // Zoom in the Google Map
        googleMap.animateCamera(CameraUpdateFactory.zoomTo(15));

	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		// AnttiV: Listn karttatyyppimenu karttankymn
		getMenuInflater().inflate(R.menu.map_type_menu, menu);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// TODO Auto-generated method stub
		// AnttiV: Helppo tapa vaihtaa karttatyyppi lennossa...
		switch (item.getItemId()) {
		     case R.id.map_type_normal:
		    	 googleMap.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		    	 return true;
		     case R.id.map_type_satellite:
		    	 googleMap.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
		    	 return true;
		     case R.id.map_type_terrain:
		    	 googleMap.setMapType(GoogleMap.MAP_TYPE_TERRAIN);
		    	 return true;
		     case R.id.map_type_hybrid:	 
		    	 googleMap.setMapType(GoogleMap.MAP_TYPE_HYBRID);
		    	 return true;
			 default:
				return super.onOptionsItemSelected(item);
		}
	}
	@Override
	public void onMapLongClick(LatLng koordinaatit) {
		// TODO Auto-generated method stub
		// AnttiV: Laita markkeri kartalle, jos kartaa painetaan kauan
		googleMap.addMarker(new MarkerOptions().position(koordinaatit).title(koordinaatit.toString()));

	}
	

	public void addPersonMarker(LatLng koordinaatit, String name) {

		// AnttiV: Laita oppilaan markkeri kartalle, jos kartaa painetaan kauan
		googleMap.addMarker(new MarkerOptions().position(koordinaatit).title(koordinaatit.toString()));

	}	
	

	@Override
	public void onMapClick(LatLng koordinaatit) {
		// TODO Auto-generated method stub
		// AnttiV: Keskit karttaa jos painetaan karttaa
		googleMap.animateCamera(CameraUpdateFactory.newLatLng(koordinaatit));
	}

}
